
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Reboot Presents......
;;


intro_seq:		bsr 	info_init
				bsr		intro_sequence
				rts


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Pallette Routine: fade to black
;;

fadepal_down:   move.w  #32,d6

.dofader:       bsr     wait_frame_intro

				lea     $f00400,a0      			; hardware pallette
                move.w  #255,d7         			; 256 colours
.palloop:       move.w  (a0),d0     
                move.w  d0,d1
                move.w  d0,d2
                and.w   #%1111100000000000,d0
                and.w   #%0000011111000000,d1
                and.w   #%0000000000111110,d2
.d0:            tst.w   d0
                beq.s   .d1
                sub.w   #%0000100000000000,d0
.d1:            tst.w   d1
                beq.s   .d2
                sub.w   #%0000000001000000,d1
.d2:            tst.w   d2
                beq.s   .merge
                sub.w   #%0000000000000010,d2
.merge:         or.w    d1,d0
                or.w    d2,d0
				cmp.l	#$f00400,a0
				bne.s	.noback
				move.w	d0,BG
.noback:        move.w  d0,(a0)+
                dbf     d7,.palloop
                dbf     d6,.dofader
				
				lea		$f00400,a0
				move.l	#127,d0
.forceblk:		clr.l	(a0)+
				dbra	d0,.forceblk
				
                rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Pallette Routine: fade from black to required pallette
;;

fadepal_up:     move.w  #32,d6
                move.l  a1,a4

.dofader2:      bsr     wait_frame_intro
				lea     $f00400,a0      			; hardware pallette
                move.l  a4,a1
                move.w  #255,d7         			; 256 colours
.palloop2:      move.w  (a0),d0         			; word in pallette     
                move.w  (a1)+,d3        			; required word
                move.w  d0,d1
                move.w  d0,d2
                move.w  d3,d4
                move.w  d3,d5
                and.w   #%1111100000000000,d0
                and.w   #%0000011111000000,d1
                and.w   #%0000000000111110,d2
                and.w   #%1111100000000000,d3
                and.w   #%0000011111000000,d4
                and.w   #%0000000000111110,d5
.d0_1:          cmp.w   d0,d3
                beq.s   .d1_2
                add.w   #%0000100000000000,d0
.d1_2:          cmp.w   d1,d4
                beq.s   .d2_3
                add.w   #%0000000001000000,d1
.d2_3:          cmp.w   d2,d5
                beq.s   .merge_2
                add.w   #%0000000000000010,d2
.merge_2:       or.w    d1,d0
                or.w    d2,d0
				cmp.l	#$f00400,a0
				bne.s	.noback
				move.w	d0,BG
.noback:        move.w  d0,(a0)+
                dbf     d7,.palloop2
                dbf     d6,.dofader2
                rts
				
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Vertical Blank Interupt
;;

VB_INTERUPT_INTRO:    
				movem.l d0-d7/a0-a6,-(a7)

                jsr     copy_olist              	; use Blitter to update active list from shadow
				sub.w	#1,ticksintro
				jsr		musicplayer+8
				
.done_vbl:      move.w  #$101,INT1              	; Signal we're done
                move.w  #$0,INT2
                
                movem.l (a7)+,d0-d7/a0-a6
                rte	
				
wait_frame_intro:
				move.w	d7,-(a7)
				move.w	ticksintro,d7
.argh:			cmp.w	ticksintro,d7
				beq.s	.argh
				move.w	(a7)+,d7
				rts

				.phrase

font_x:			incbin "INTROGFX/atarisys.fnt"
				.even

info_init:		lea font_x(pc),a0			; Font offsets for plotter
				move.l a0,d0
				move.l d0,d1
				move.l d0,d2
				add.l #40*9,d1
				add.l #40*18,d2
				lea asciintro,a1
				move.w #39,d3
.adder:			move.l d0,(a1)
				move.l d1,160(a1)
				move.l d2,320(a1)
				addq.l #1,d0
				addq.l #1,d1				; legacy ST code botched for Jaguar
				addq.l #1,d2
				lea 4(a1),a1
				dbra d3,.adder
				rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Text plotting routine
;;
;; call with a1 pointing at text
;;       

info:			lea display_bmp,a0
				add.l (a1)+,a0
info2:			lea intro_add(pc),a3
				move.l a0,(a3)
.loop:			moveq.l #0,d0
				move.b (a1)+,d0
				bpl.s .write
				cmp.b #-1,d0
				beq.s .wrap
.nextline:		move.l (a3),a0
				add.l #40*9,a0
				move.l a0,(a3)
				bra.s .loop
.wrap:			rts

.write:			sub.b #' ',d0
				add d0,d0
				add d0,d0
				lea asciintro,a2
				move.l (a2,d0),a2
				bsr.s .plotit
				bra .loop

.plotit:		move.b (a2),(a0)
				move.b	40(a2),40(a0)
				move.b	80(a2),80(a0)
				move.b	120(a2),120(a0)
				move.b	160(a2),160(a0)
				move.b	200(a2),200(a0)
				move.b	240(a2),240(a0)
				move.b	280(a2),280(a0)
				add.l 	#1,a0
				rts
		
intro_sequence:	lea     ob_list1,a0             	; start of OL
                jsr     build_header_intro          ; build BRA header

				move.l	a0,hobs_obj					; store object address in table
				move.l	#hobs_bmp,a1
                move.l  #bitmapobject,d0        	; type
                move.l  #136,d1 	                ; height
                move.l  #96/2,d2             		; bytes to next line
                move.l  #2,d3                   	; 4-Bit
                move.l  #0,d4                   	; non transparent
				move.l	#96/2,d5
                jsr     CreateObject	

				move.l	#stopobject,d0
				jsr		CreateObject
 				
				move.l	hobs_obj,a0
				move.l	#700,d0
				move.l	#700,d1
				jsr		setup_object_xy
				
                move.l  #VB_INTERUPT_INTRO,LEVEL0   ; Install 68K LEVEL0 handler
                move.w  a_vde,d0                	; Must be ODD
                sub.w   #16,d0
                ori.w   #1,d0
                move.w  d0,VI

                move.w  #1,INT1                 	; Enable video interrupts
                and.w   #$f8ff,sr		
 
                bsr     wait_frame_intro            ; Stop the OP from freaking

                move.l  #ob_list,d0
                swap    d0
                move.l  d0,OLP                  	; Object Processor is GO!

				lea		button_bmp,a0
				lea		$160000,a1
				jsr		unpacker

				bsr		fadepal_down
				
				move.l	hobs_obj,a0
				move.l	#176-(96/2),d0
				move.l	#148-(136/2),d1
				tst.w	ntsc_flag
				bmi.s	.palset
				sub.l	#16,d1
.palset:		jsr		setup_object_xy

				lea		hobs_pal,a1
				bsr		fadepal_up	
			
				lea		logo_pallettes,a0
				lea		$150000,a1
				move.l	#(256*5)/4,d7
.movepal:		move.l	(a0)+,(a1)+
				dbra	d7,.movepal
				
				lea		dbug_bmp,a0
				lea		$100000,a1
				jsr		unpacker
				lea		rg_bmp,a0
				lea		$110000,a1
				jsr		unpacker
				lea		present_bmp,a0
				lea		$120000,a1
				jsr		unpacker
				lea		jagboot_bmp,a0
				lea		$130000,a1
				jsr		unpacker
				lea		production_bmp,a0
				lea		$140000,a1
				jsr		unpacker

				bsr		fadepal_down

				move.l	hobs_obj,a0
				move.l	#900,d0
				move.l	#900,d1
				jsr		setup_object_xy
				
				move.w	#0,$f00402+(32*15)				

; DBUG
				move.l	hobs_obj,a0
				move.l	#$100000,a1
                move.l  #bitmapobject,d0        	; type
                move.l  #185,d1 	                ; height
                move.l  #56,d2             			; bytes to next line
                move.l  #3,d3                 		; 8-Bit
                move.l  #0,d4                  		; non transparent;
				move.l	#56,d5
                jsr     CreateObject					

				move.l	#137+16,d0
				move.l	#12+20,d1
				bsr		tgtw_waitrout

				lea		logo_pallettes,a1
				bsr		do_fade_up_down
; RG
				move.l	hobs_obj,a0
				move.l	#$110000,a1
                move.l  #bitmapobject,d0       		; type
                move.l  #143,d1 	      			; height
                move.l  #256,d2             		; bytes to next line
                move.l  #3,d3                   	; 8-Bit
                move.l  #0,d4                   	; non transparent;
				move.l	#256,d5
                jsr     CreateObject					

				move.l	#32+16,d0
				move.l	#37+20,d1
				bsr		tgtw_waitrout

				lea		logo_pallettes+(512*1),a1
				bsr		do_fade_up_down
; PRESENT
				move.l	hobs_obj,a0
				move.l	#$120000,a1
                move.l  #bitmapobject,d0        	; type
                move.l  #27,d1 	                 	; height
                move.l  #88,d2             			; bytes to next line
                move.l  #3,d3                   	; 8-Bit
                move.l  #0,d4                   	; non transparent;
				move.l	#88,d5
                jsr     CreateObject					

				move.l	#116+16,d0
				move.l	#85+20,d1
				bsr		tgtw_waitrout

				lea		logo_pallettes+(512*2),a1
				bsr		do_fade_up_down
; jagboot
				move.l	hobs_obj,a0
				move.l	#$130000,a1
                move.l  #bitmapobject,d0        	; type
                move.l  #60,d1 	                 	; height
                move.l  #320,d2             		; bytes to next line
                move.l  #3,d3                   	; 8-Bit
                move.l  #0,d4                   	; non transparent;
				move.l	#320+20,d5
                jsr     CreateObject					

				move.l	#0+16,d0
				move.l	#70+20,d1
				bsr		tgtw_waitrout

				lea		logo_pallettes+(512*3),a1
				bsr		do_fade_up_down	

; Prodction
				move.l	hobs_obj,a0
				move.l	#$140000,a1
                move.l  #bitmapobject,d0        	; type
                move.l  #28,d1 	                 	; height
                move.l  #104,d2             		; bytes to next line
                move.l  #3,d3                   	; 8-Bit
                move.l  #0,d4                   	; non transparent;
				move.l	#104,d5
                jsr     CreateObject					

				move.l	#108+16,d0
				move.l	#81+20,d1
				bsr		tgtw_waitrout

				lea		logo_pallettes+(512*4),a1
				bsr		do_fade_up_down
; Press The Button
				move.l	hobs_obj,a0
				move.l	#$160000,a1
                move.l  #bitmapobject,d0        	; type
                move.l  #227,d1 	                ; height
                move.l  #320,d2             		; bytes to next line
                move.l  #3,d3                   	; 8-Bit
                move.l  #0,d4                   	; non transparent;
				move.l	#320,d5
                jsr     CreateObject					

				move.l	#18,d0
				move.l	#16,d1
				bsr		tgtw_waitrout
				
				lea		logo_pallettes+(512*5),a1
				bsr		fadepal_up

.argh:			jsr		readpad
				jsr		handle_input
				
				tst.w	dpad_b
				beq		.argh
				
				bsr		fadepal_down
				
				
				bsr		thou_shalt
								
				bsr		wait_frame_intro

                move.l  #temp_stop_obj,d0
                swap    d0
                move.l  d0,OLP                  	; Object Processor is GO!

				bsr		wait_frame_intro
				
				rts
				
tgtw_waitrout:
				move.l	hobs_obj,a0
				tst.w	ntsc_flag
				bpl.s	.ntscset
				subq	#4,d0
				add.l	#10,d1
.ntscset:		jsr		setup_object_xy	
				rts

do_fade_up_down:
				bsr		fadepal_up
				
				move.l	#2*50,d7
.fuck_you_tbag:	bsr		wait_frame_intro
				dbra	d7,.fuck_you_tbag
				 
				bsr		fadepal_down
				rts
				
rainbow			equ		$100000	
				
thou_shalt:
				lea 	rainbow,a0
				move.l	#(40*9*25)/4,d7
.xwipe:			clr.l	(a0)+
				dbra	d7,.xwipe

				bsr		wait_frame_intro

                move.l  #temp_stop_obj,d0
                swap    d0
                move.l  d0,OLP                  	; Object Processor is GO!
			
				lea		rainbow,a0
				lea		rainbow_txt,a1
				bsr		info2
				
				move.l	hobs_obj,a0
				lea		rainbow,a5
				lea		text_objs(pc),a6
				moveq	#0,d6
				move.w	#24,d7						; 25 objects
.maketext:		move.l	a0,(a6)						; store object address in table
				move.l	a5,a1
                move.l  #bitmapobject,d0        	; type
                move.l  #8,d1 	                 	; height
                move.l  #40,d2	             		; bytes to next line
                move.l  #0,d3                   	; 1-Bit
                move.l  #1,d4                   	; transparent
				move.l	#40,d5
				movem.l	d6/d7/a5/a6,-(a7)
                jsr     CreateObject
				movem.l	(a7)+,d6/d7/a5/a6
				move.l	(a6)+,a1					; pointer to object
				add.w	.diff,d6
				eor.w	#1,.diff
				move.w	d6,d0
				and.l	#%1111,d0
				lsl.w	#8,d0						; shift up one byte
				lsl.w	#1,d0
				;		  7654321076543210 
				and.w	#%1110000000111111,10(a1)	; mask out index
				or.w	d0,10(a1)					; or in next index 
				lea		8*40(a5),a5
				dbra	d7,.maketext
				
				move.l	#stopobject,d0
				jsr		CreateObject

				lea		text_objs(pc),a6
				move.l	#30,d6
				move.w	#24,d7	
.setuptxt:		move.l	(a6)+,a0
				moveq	#15,d0
				move.l	d6,d1
				movem.l	d6/d7/a5/a6,-(a7)
				jsr		setup_object_xy
				movem.l	(a7)+,d6/d7/a5/a6
				add.l	#8,d6
				dbra	d7,.setuptxt

				
                bsr     wait_frame_intro            ; Stop the OP from freaking
			
                move.l  #ob_list,d0
                swap    d0
                move.l  d0,OLP                  	; Object Processor is GO!
				
.argh:			move.w	#1,d7		
.gorftwat:		bsr		wait_frame_intro
				dbra	d7,.gorftwat
				lea		$f00402+(32*15),a0
				moveq	#14,d7
.rotate:		move.w	-32(a0),(a0)
				lea		-32(a0),a0
				dbra	d7,.rotate

				move.l	colptr,a1
.getcol:		move.w	(a1)+,d0
				cmp.l	#colours_end,a1
				bne.s	.insert_col
				lea		colours,a1
				bra.s	.getcol
.insert_col:	move.w	d0,$f00402
				move.l  a1,colptr
				
				jsr		readpad
				jsr		handle_input
				
				tst.w	dpad_b
				beq		.argh

				rts
				
.diff:			dc.w	0

build_header_intro:
				move.l  a0,d0               ; address if bra not taken
				sub.l   #ob_list1,d0        ;
                add.l   #ob_list,d0         ;
                add.l   #32,d0              ; next BRA object
                lsr.l   #3,d0               ;
                lsl.l   #8,d0               ;
                clr.l   (a0)                ;
                move.l  #$00008003,4(a0)    ; bra if yp<0
                or.l    d0,2(a0)            ; link to next BRA
                lea     8(a0),a0            ;
                jsr     stopob              ; write stop object (before top)
                lea     16(a0),a0           ; next object here

                move.l  a0,d0               ; calc address of 1st actual
                sub.l   #ob_list1,d0        ; object (after the next STOP)
                add.l   #ob_list,d0         ;
                add.l   #32,d0              ;
                lsr.l   #3,d0               ;
                lsl.l   #8,d0               ;
                clr.l   (a0)                ;
                move.l  #$00004003,4(a0)    ; bra is yp>value
                or.l    d0,2(a0)            ; link to first object!

				move.w	CONFIG,d6
				andi.w	#VIDTYPE,d6
				beq		.pal
				move.l	#492,d0				; 492 lines = full NTSC frame
				bra		.ntsc
.pal:			move.l	#560,d0				; 580 lines = full PAL frame

.ntsc:          lsl.l   #3,d0               ;
                or.l    d0,4(a0)            ;
                lea     8(a0),a0            ; next object
                jsr     stopob              ; is a STOP
				lea     16(a0),a0           ; address for next REAL object

                rts

				
colptr:			dc.l	colours+30
colours:		incbin	"INTROGFX/colours.j16"
colours_end:	dc.l	"WANK"
				
rainbow_txt:	dc.b  	"      Welcome to Beebris Tribute!",-2
		dc.b	-2
		dc.b	" The original Beebris was released in",-2
		dc.b	" 1991 on the Atari ST as part of a mini",-2
		dc.b	' demo called "Apathetic Games", and can',-2
		dc.b	" be found at dbug-automation.co.uk",-2
		dc.b	" along with the source code.",-2
		dc.b	-2
		dc.b	" This 'Tribute' version was done in",-2
		dc.b	" around a week by Reboot, and has",-2
		dc.b	" had the graphics slightly enhanced",-2
		dc.b	" for the jaguar, as well as using the",-2
		dc.b	" title module in game as was always",-2
		dc.b	" intended by Floyd (He who wrote it!)",-2
		dc.b	-2
		dc.b	" We hope you enjoy playing this game",-2
		dc.b	" as much as we have whilst making it,",-2
		dc.b	" both now, and 18 years ago ;-)",-2
		dc.b	-2
		dc.b	" Cyrano Jones / GGN / SH3 - REBOOT 2009",-2
		dc.b	-2
		dc.b	"        PRESS B TO PLAY THE GAME",-1
		even
rainbow_end:
				.even
text_objs:		
				.rept	25
				dc.l	0
				.endr
				
				.phrase

intro_add:		dc.l	0
no_tracking:	dc.l	0

unpacker:
				include "_ice.s"
									
                .dphrase
		
ticksintro:     .dc.l   0 
asciintro:
				.rept	120
				dc.l	0
				.endr

				.phrase
				
display_obj:	.dc.l	0
workbench_obj:	.dc.l	0
live_workbench_obj:	.dc.l	0
new_pallette:	
				.rept 256
				.dc.w	0
				.endr
				
				.phrase
display_bmp:
				.rept	40*8
				.dc.b	0
				.endr

				.dphrase
temp_stop_obj:	dc.l	0,4
hobs_obj:		dc.l	0
				.dphrase
hobs_bmp:		incbin  "INTROGFX/hobs.jag"
				.phrase
hobs_pal:		incbin 	"INTROGFX/hobs.pal"
				.rept	256
				dc.w	0
				.endr
			
				.dphrase
dbug_bmp:		incbin "INTROGFX/bugblox.ICE"
				.even
rg_bmp:			incbin "INTROGFX/resgods.ICE"
				.even
present_bmp:	incbin "INTROGFX/LOG-PSNT.ICE"
				.even
jagboot_bmp:	incbin "INTROGFX/LOG-JWBT.ICE"
				.even
production_bmp:	incbin "INTROGFX/LOG-PROD.ICE"
				.even

logo_pallettes:	incbin "INTROGFX/bugblox.PAL"
				incbin "INTROGFX/resgods.PAL"
				incbin "INTROGFX/LOG-PSNT.PAL"
				incbin "INTROGFX/LOG-JWBT.PAL"
				incbin "INTROGFX/LOG-PROD.PAL"
				incbin "INTROGFX/title2.PAL"
				.phrase
						
button_bmp:		incbin "INTROGFX/title2.ICE"
				.even
			
_trashram:		




